Test compiler to simulate xkbcomp usage
authorDan Nicholson <dbn.lists@gmail.com>
Sat, 4 Apr 2009 16:14:20 +0000 (09:14 -0700)
committerDan Nicholson <dbn.lists@gmail.com>
Sat, 4 Apr 2009 16:14:20 +0000 (09:14 -0700)
Added a test program, rulescomp, which takes a RMLVO set and generates a
XkbcDescPtr. This is essentially what the xserver will do, except that we
still need to access some xkbcomp internal API to make it work.

test/.gitignore
test/Makefile.am
test/rulescomp.c [new file with mode: 0644]
test/rulescomp.sh [new file with mode: 0755]

index ddf7b39..1f8f4a2 100644 (file)
@@ -1 +1,2 @@
+rulescomp
 xkey
index 18ac375..4e35e12 100644 (file)
@@ -1,9 +1,13 @@
 INCLUDES = -I$(top_srcdir)/include
 AM_CFLAGS = $(X11_CFLAGS) $(CWARNFLAGS)
 
-check_PROGRAMS = xkey
+TESTS_ENVIRONMENT = $(SHELL)
+
+check_PROGRAMS = xkey rulescomp
+TESTS = xkey.sh rulescomp.sh
+
 xkey_SOURCES = xkey.c
 xkey_LDADD = $(top_builddir)/src/libxkbcommon.la
 
-TESTS = xkey.sh
-TESTS_ENVIRONMENT = $(SHELL)
+rulescomp_SOURCES = rulescomp.c
+rulescomp_LDADD = $(top_builddir)/src/libxkbcommon.la
diff --git a/test/rulescomp.c b/test/rulescomp.c
new file mode 100644 (file)
index 0000000..5a54d74
--- /dev/null
@@ -0,0 +1,68 @@
+/*
+Copyright 2009 Dan Nicholson
+
+Permission is hereby granted, free of charge, to any person obtaining a
+copy of this software and associated documentation files (the "Software"),
+to deal in the Software without restriction, including without limitation
+the rights to use, copy, modify, merge, publish, distribute, sublicense,
+and/or sell copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
+ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+Except as contained in this notice, the names of the authors or their
+institutions shall not be used in advertising or otherwise to promote the
+sale, use or other dealings in this Software without prior written
+authorization from the authors.
+*/
+
+#include <stdlib.h>
+#include <stdio.h>
+#include "X11/extensions/XKBcommon.h"
+#include <X11/extensions/XKBstrcommon.h>
+#include "../src/xkbcomp/utils.h"
+#include "../src/xkbcomp/xkbpath.h"
+
+int main(int argc, char *argv[])
+{
+    int i;
+    char *rules = NULL;
+    XkbRF_VarDefsRec defs;
+    XkbcDescPtr xkb;
+
+    /* Require rmlvo */
+    if (argc < 6) {
+        fprintf(stderr, "Not enough arguments\n");
+        fprintf(stderr, "Usage: %s RULES MODEL LAYOUT VARIANT OPTIONS\n",
+                argv[0]);
+        exit(1);
+    }
+
+    rules = argv[1];
+    defs.model = argv[2];
+    defs.layout = argv[3];
+    defs.variant = argv[4];
+    defs.options = argv[5];
+
+    uSetErrorFile(NULL);
+    XkbInitIncludePath();
+    XkbAddDefaultDirectoriesToPath();
+    XkbcInitAtoms();
+
+    xkb = XkbcCompileKeymapFromRules(rules, &defs);
+
+    if (!xkb) {
+        fprintf(stderr, "Failed to compile keymap\n");
+        exit(1);
+    }
+
+    return 0;
+}
diff --git a/test/rulescomp.sh b/test/rulescomp.sh
new file mode 100755 (executable)
index 0000000..5a5742e
--- /dev/null
@@ -0,0 +1,13 @@
+#!/bin/sh
+
+srcdir=${srcdir-.}
+builddir=${builddir-.}
+
+compile()
+{
+    ${builddir}/rulescomp "$1" "$2" "$3" "$4" "$5" || exit $?
+}
+
+compile base pc105 us "" ""
+compile evdev pc105 us intl ""
+compile evdev pc105 us intl grp:alts_toggle